/*
 * NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDepEmpiezaCeroDep.java
 *
 * Created on 9 de abril de 2007, 08:02 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 * @author Julian
 */
public class NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDepEmpiezaCeroDep
		extends AbstractRule {

	private Pattern pattern;

	public NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDepEmpiezaCeroDep() {
		String patternStr = "[^A-Z0-9/Ñ]";
		pattern = Pattern.compile(patternStr);

	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (!codigoNovedad.equals((String) getParams()[1])) {
			return false;
		}

		if (registro[new Integer((String) getParams()[2]).intValue()]
				.equals(getParams()[3])) {
			if (field.length() < new Integer((String) getParams()[4])
					.intValue()
					|| field.length() > new Integer((String) getParams()[5])
							.intValue())
				return true;
			if (field.charAt(0) == ('0')) {
				return true;
			}
			Matcher matcher = pattern.matcher(field);
			return matcher.find();

		}

		return false;
	}

}
